{ 001104-3.PAS                                                              }
{ 2000-11-04 programmeerimisolmpiaadi 3. lesande lahendus                 }
{    TEADE                                                                  }
{ Indrek Jentson                                                            }
{ Testitud: TP 6.0, FPC 0.99.10                                             }

const
  liikmete_max_arv  = 100;
  sisendfaili_nimi  = 'TEADE.SIS';
  valjundfaili_nimi = 'TEADE.VAL';

var
  N : Integer; { hingu liikmete arv }
  X : Integer; { teate lhetaja number }
  Y : array[1..liikmete_max_arv] of Integer; { teate leviku massiiv }
  {
    Y[z] = 0, Kui hingu liige _z_ ei ole teadet ktte saanud
    Y[z] = 1, Kui hingu liige _z_ on teate ktte saanud
    Y[z] = 2, Kui hingu liige _z_ on teate edasi andnud

  Antud lesandes on kige otstarbekam andmeid ksitleda graafi G abil.
  Graafi tippudeks on sellisel juhul hingu liikmed ja kontaktandmete
  valdamist kujutame graafi orienteeritud serva abil.

  G[a, b] = True siis, kui liige _a_ teab liikme _b_ piiparinumbrit.
  }
  G : array[1..liikmete_max_arv, 1..liikmete_max_arv] of Boolean;

function Andmete_Sisestamine : Boolean;
var
  i, j : Integer;
  K    : Integer;    { teadaolevate kontaktide arv }
  L    : Integer;    { teadaoleva liikme number }
  SF   : text;       { sisendandmete fail }
begin
  assign(SF, sisendfaili_nimi);
  {$I-}
  reset(SF);
  {$I+}
  if ioresult = 0 then
    begin
    { loeme sisse liikmete arvu }
    read(SF, N);
    { "puhastame" seosed liikmete vahel ja }
    { liikmete teadlikkust nitava massiivi }
    for i := 1 to N do
      begin
      Y[i] := 0;
      for j := 1 to N do
        G[i,j] := False;
      end;
    { loeme sisse teadaantud seosed }
    for i := 1 to N do
      begin
      { loeme sisse i-nda liikme kontaktide arvu }
      read(SF, K);
      { loeme sisse K liikme numbrid }
      for j := 1 to K do
        begin
        read(SF, L);
        { tiendame seoseid }
        G[i, L] := True;
        end;
      end;
    { loeme sisse teate lhetaja numbri }
    read(SF, X);
    { ja mrgime ra, et tema teab teadet }
    Y[X] := 1;

    close(SF);
    Andmete_Sisestamine := True; { andmete sisselugemine nnestus }
    end
  else
    Andmete_Sisestamine := False; { andmete sisselugemine ebannestus }
end;

procedure Arvutamine;
  { Leiame need liikmed, kellele saab teate edasi anda. }
var
  i, j : Integer;
begin
  i := X;
  repeat
    { _i_ tleb edasi neile, kellele saab ja kes veel ei tea }
    for j := 1 to N do
      if G[i,j] and (Y[j] = 0) then
        Y[j] := 1;
    { mrgime ra, et _i_ on teate edastanud }
    Y[i] := 2;
    { otsime uue liikme, kes teab teadet ja pole veel seda edasi andnud }
    i := 1;
    while (Y[i] <> 1) and (i < N) do inc(i);
  until Y[i] <> 1; { kuni pole enam neid, kes saavad teadet levitada }
end;

procedure Andmete_valjastamine;
var
  i, vastus : integer;
  VF        : text;       { vljundandmete fail }
begin
  assign(VF, valjundfaili_nimi);
  {$I-}
  rewrite(VF);
  {$I+}
  if ioresult = 0 then
    begin
    vastus := 0;
    { loeme kokku need hingu liikmed, kes teadet ei saanud }
    for i := 1 to N do
      if Y[i] = 0 then inc(vastus);

    writeln(VF, vastus);
    close(VF);
    end;
end;

begin { phiprogramm }

  if Andmete_Sisestamine then
    begin
    Arvutamine;
    Andmete_valjastamine;
    end;

end.
