{ kontroll.pas                                                              }
{ 2000-11-04 programmeerimisolmpiaadi 5. lesande testija                  }
{    RISTSNA                                                               }
{ Ahto Truu                                                                 }

{ Tegelikult pole see pris tielik testija -- ta genereerib lahenduseks    }
{ antud ristsnale vastava sisendfaili (selles suunas teisenduse tulemus    }
{ on lesande tingimustega heselt mratud) ja edasi kontrollitakse juba   }
{ muude vahenditega, kas see sisend on ka selline, nagu programmile ette    }
{ anti. Kui on, siis on lahendus OK, muidu ilmselt mitte.                   }

{$I-}

const
   max = 30;                             { maksimaalne ridade, veergude arv }

var
   f : text;
   r, v : integer;                                       { ristsna mtmed }
   a : array [1..max, 1..max] of char;                       { ristsna ise }
   b : array [1..max*max] of string[max];                        { snastik }
   n, i, j, k : integer;
   s : string;

{ lisab reas olevad snad snastikku }
procedure sonad (var s : string);
var i1, i2 : integer;
begin
   i1 := 1;
   while i1 < length (s) do begin
      i2 := i1;
      while (i2 <= length (s)) and (s[i2] in ['A'..'Z']) do
         i2 := i2 + 1;
      if i2 - i1 > 1 then begin
         n := n + 1;
         b[n] := copy (s, i1, i2 - i1);
      end;
      i1 := i2;
      while (i1 <= length (s)) and not (s[i1] in ['A'..'Z']) do
        i1 := i1 + 1;
   end;
end;

begin { phiprogramm }
   if paramcount <> 3 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail abifail');
      halt (1);
   end;

   { loeme ristsna mtmed algsest sisendfailist }
   assign (f, paramstr (1)); reset (f);
   readln (f, r, v);
   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;

   { loeme ristsna lahenduse vljundfailist }
   assign (f, paramstr (2)); reset (f);
   for i := 1 to r do begin
      readln (f, s);
      if length (s) <> v then begin
         writeln ('Lubamatu pikkusega rida failis ', paramstr (2));
         halt (1);
      end;
      for j := 1 to v do begin
         if not (s[j] in ['A'..'Z', '.', '+']) then begin
            writeln ('Lubamatu smbol failis ', paramstr (2));
            halt (1);
         end;
         a[i, j] := s[j];
      end;
   end;
   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   { paneme leitud snad snastikuks kokku }
   n := 0;
   for i := 1 to r do begin
      s := '';
      for j := 1 to v do
         s := s + a[i, j];
      sonad (s);
   end;
   for j := 1 to v do begin
      s := '';
      for i := 1 to r do
         s := s + a[i, j];
      sonad (s);
   end;

   { sorteerime snastiku }
   for i := 1 to n do begin
      k := i;
      for j := i + 1 to n do
         if b[k] > b[j] then
            k := j;
      if k > i then begin
         s := b[i]; b[i] := b[k]; b[k] := s;
      end;
   end;

   { konstrueerime vastusele vastava sisendfaili }
   assign (f, paramstr (3)); rewrite (f);
   writeln (f, r, ' ', v, ' ', n);
   for i := 1 to r do begin
      for j := 1 to v do
         if a[i][j] = '+' then
            write (f, '+')
         else
            write (f, '.');
      writeln (f);
   end;
   for i := 1 to n do
      writeln (f, b[i]);
   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (3), ' kirjutamisel');
      halt (1);
   end;

   writeln ('Korras');
end.
