{ 001104-4.PAS                                                              }
{ 2000-11-04 programmeerimisolmpiaadi 4. lesande lahendus                 }
{    FAILID                                                                 }
{ Oleg Mrk                                                                 }
{ Testitud: TP 7.0, FPC 0.99.10                                             }

{$R+}{$Q+}{$I+}

const
     MAX_N = 10000;     {Maksimaalne sektorite arv}
     MAX_M = 10000;     {Maksimaalne failide arv}

     SISEND_FAIL = 'FAILID.SIS';
     VALJUND_FAIL = 'FAILID.VAL';

type
    stabel = array[0 .. (MAX_N - 1)] of integer;
    ftabel = array[1 .. MAX_M] of integer;

var
 n, m : integer;             { U"lesande parameetrid }

 tabel : ^stabel;            { Sektorite sisu }
 kordi : ^stabel;            { Mitmele failile kuulub sektor }
 kylastus : ^stabel;         { Kasutatakse failide la"bimisel tsu"klide va"ltimiseks }
 failide_algused : ^ftabel;  { Failide algussektorid }

 vastus1 : integer; { Vastus esimesele ku"simusele: mitu faili on loetavad }
 vastus2 : integer; { Vastus tesiele ku"simusele}


procedure loe_andmed;
var
 f : text;
 l : integer;
begin
 assign(f, SISEND_FAIL);
 reset(f);

 { Loeme sisse parameetrid }
 readln(f, n, m);

 { Tyu"i rida }
 readln(f);

 { Loeme sisse sektorid }
 for l := 0 to n-1 do readln(f, tabel^[l]);

 { Tyu"i rida }
 readln(f);

 { Loeme sisse failide algused }
 for l := 1 to m do readln(f, failide_algused^[l]);

 close(f);
end;


{ Siin lahendatakse u"lesannet }
procedure lahenda;
var
 l : integer;
 jooksev_sektor : integer;
begin
 { Algva"a"rtustame massiivid ja muutujad }
 for l := 0 to n-1 do
 begin
      kordi^[l] := 0;
      kylastus^[l] := 0;
 end;

 vastus1 := 0;
 vastus2 := 0;

 { Iga faili puhul }
 for l := 1 to m do
 begin
      jooksev_sektor := failide_algused^[l];

      { La"bime faili }
      while (true) do
      begin

            { Kontrollime et ja"a"nud tsu"klisse }
            if (kylastus^[jooksev_sektor] = l) then break;

            { Va"rskendame statistikat }
            inc(kordi^[jooksev_sektor]);
            kylastus^[jooksev_sektor] := l;


            if (tabel^[jooksev_sektor] >= 0) then
                { La"hme ja"rgmisesse sektorisse }
                jooksev_sektor := tabel^[jooksev_sektor]
            else if (tabel^[jooksev_sektor] = -1) then
            begin
                 { Faili lo~pp }
                 inc(vastus1);
                 if (kordi^[jooksev_sektor] - 1 > vastus2) then
                    vastus2 := kordi^[jooksev_sektor] - 1;

                 break;
            end
            else break; { Fail ei ole loetav }
      end;
 end;

 { Vastus on valmis }
end;


procedure kirjuta_andmed;
var
 f : text;
begin
 assign(f, VALJUND_FAIL);
 rewrite(f);

 writeln(f, vastus1, ' ', vastus2);

 close(f);
end;


procedure eralda_malu;
begin
 new(tabel);
 new(kordi);
 new(kylastus);
 new(failide_algused);
end;

procedure vabasta_malu;
begin
 dispose(tabel);
 dispose(kordi);
 dispose(kylastus);
 dispose(failide_algused);
end;


begin
 eralda_malu;
 loe_andmed;
 lahenda;
 kirjuta_andmed;
 vabasta_malu;
end.
