{ 001104-5.PAS                                                              }
{ 2000-11-04 programmeerimisolmpiaadi 5. lesande lahendus                 }
{    RISTSNA                                                               }
{ Ahto Truu                                                                 }
{ Testitud: TP 6.0, FPC 0.99.10                                             }

const
   sisf = 'rist.sis';                                    { sisendfaili nimi }
   valf = 'rist.val';                                   { vljundfaili nimi }

const
   must = '+';                                          { musta ruudu this }
   tuhi = '.';                                          { valge ruudu this }

const
   maxr = 30;                                      { maksimaalne ridade arv }
   maxv = 30;                                    { maksimaalne veergude arv }
   maxp = 30;                   { maksimaalne sna pikkus: max (maxr, maxv) }

type
   sonaviit = ^sona;
   sona = record                                           { snastiku sna }
      s : string[maxp];                                              { sna }
      v : boolean;                                               { kas vaba }
      j : sonaviit;                                              { jrgmine }
   end;
   teek = record                                                 { snastik }
      n : integer;                                             { snade arv }
      a : array [1..maxp, 'A'..'Z'] of sonaviit;     { snad pikkuste kaupa }
   end;

type
   ruut = record                                        { ristsna ks ruut }
      m : char;                                          { ruudus olev mrk }
      n : integer;                                          { kasutuste arv }
      ar, av : integer;                                { siit sna alguseni }
      lr, lv : integer;                                  { siit sna lpuni }
      sr, sv : sonaviit;                             { sna, mis siit algab }
   end;
   rist = record                                                 { ristsna }
      r, v : integer;                                             { mtmed }
      a : array [1..maxr, 1..maxv] of ruut;                        { ruudud }
   end;

type
   koht = record                                              { jrjehoidja }
      r, v, d : integer;                           { rida, veerg, diagonaal }
      s : integer;                              { suund: 0 paremale, 1 alla }
      t : boolean;                                          { kas tagurdame }
   end;

{ loeb antud failist ristsna ruudustiku kirjelduse }
procedure loe_rist (var f : text; var r : rist);
var rr, vv : integer;
begin
   for rr := 1 to r.r do begin
      for vv := 1 to r.v do begin
         read (f, r.a[rr, vv].m);
         r.a[rr, vv].n := 0;
         r.a[rr, vv].sr := nil;
         r.a[rr, vv].sv := nil;
      end;
      readln (f);
   end;
   { arvutame iga ruudu jaoks seda lbiva sna algus- ja lppveeru }
   for rr := 1 to r.r do begin
      r.a[rr, 1].ar := 1;
      for vv := 2 to r.v do
         if (r.a[rr, vv].m = must) or (r.a[rr, vv - 1].m = must) then
            r.a[rr, vv].ar := vv
         else
            r.a[rr, vv].ar := r.a[rr, vv - 1].ar;
      r.a[rr, r.v].lr := r.v;
      for vv := r.v - 1 downto 1 do
         if (r.a[rr, vv].m = must) or (r.a[rr, vv + 1].m = must) then
            r.a[rr, vv].lr := vv
         else
            r.a[rr, vv].lr := r.a[rr, vv + 1].lr;
   end;
   { arvutame iga ruudu jaoks seda lbiva sna algus- ja lpprea }
   for vv := 1 to r.v do begin
      r.a[1, vv].av := 1;
      for rr := 2 to r.r do
         if (r.a[rr, vv].m = must) or (r.a[rr - 1, vv].m = must) then
            r.a[rr, vv].av := rr
         else
            r.a[rr, vv].av := r.a[rr - 1, vv].av;
      r.a[r.r, vv].lv := r.r;
      for rr := r.r - 1 downto 1 do
         if (r.a[rr, vv].m = must) or (r.a[rr + 1, vv].m = must) then
            r.a[rr, vv].lv := rr
         else
            r.a[rr, vv].lv := r.a[rr + 1, vv].lv;
   end;
end;

{ loeb antud failist snastiku snad }
procedure loe_teek (var f : text; var t : teek);
var i : integer; c : char; s : sonaviit;
begin
   for i := 1 to maxp do
      for c := 'A' to 'Z' do
         t.a[i, c] := nil;
   for i := 1 to t.n do begin
      new (s);
      readln (f, s^.s);
      s^.v := true;
      s^.j := t.a[length (s^.s), s^.s[1]];
      t.a[length (s^.s), s^.s[1]] := s;
   end;
end;

{ loeb sisendandmed }
procedure loe_sisend (var r : rist; var t : teek);
var f : text;
begin
   assign (f, sisf); reset (f);
   readln (f, r.r, r.v, t.n);
   loe_rist (f, r);
   loe_teek (f, t);
   close (f);
end;

{ seab jrjehoidja algseisu }
procedure algus (var k : koht);
begin
   k.r := 1; k.v := 1;
   k.d := k.r + k.v;
   k.s := 0;
   k.t := false;
end;

{ nihutab jrjehoidjat koha vrra edasi }
function edasi (var k : koht; var r : rist) : boolean;
begin
   if k.s = 0 then begin
      edasi := true;
      k.s := 1;
   end else if k.d < r.r + r.v then begin
      edasi := true;
      if (k.r < r.r) and (k.v > 1) then begin
         k.r := k.r + 1;
         k.v := k.v - 1;
      end else begin
         k.d := k.d + 1;
         if k.d > r.v then
            k.v := r.v
         else
            k.v := k.d - 1;
         k.r := k.d - k.v;
      end;
      k.s := 0;
   end else
      edasi := false;
   k.t := false;
end;

{ nihutab jrjehoidjat koha vrra tagasi }
function tagasi (var k : koht; var r : rist) : boolean;
begin
   if k.s = 1 then begin
      tagasi := true;
      k.s := 0;
   end else if k.d > 2 then begin
      tagasi := true;
      if (k.r > 1) and (k.v < r.v) then begin
         k.r := k.r - 1;
         k.v := k.v + 1;
      end else begin
         k.d := k.d - 1;
         if k.d > r.r then
            k.r := r.r
         else
            k.r := k.d - 1;
         k.v := k.d - k.r;
      end;
      k.s := 1;
   end else
      tagasi := false;
   k.t := true;
end;

{ paneb sna s ristsnasse kohale k }
procedure panesona (var k : koht; var r : rist; s : sonaviit);
var rr, vv, dr, dv, i : integer;
begin
   rr := k.r; vv := k.v;
   if k.s = 0 then begin
      r.a[rr, vv].sr := s;
      dr := 0; dv := 1;
   end else begin
      r.a[rr, vv].sv := s;
      dr := 1; dv := 0;
   end;
   for i := 1 to length (s^.s) do begin
      r.a[rr, vv].m := s^.s[i];
      r.a[rr, vv].n := r.a[rr, vv].n + 1;
      rr := rr + dr; vv := vv + dv;
   end;
   s^.v := false;
end;

{ eemaldab sna s ristsnast kohalt k }
procedure votasona (var k : koht; var r : rist; s : sonaviit);
var rr, vv, dr, dv, i : integer;
begin
   rr := k.r; vv := k.v;
   if k.s = 0 then begin
      r.a[rr, vv].sr := nil;
      dr := 0; dv := 1;
   end else begin
      r.a[rr, vv].sv := nil;
      dr := 1; dv := 0;
   end;
   for i := 1 to length (s^.s) do begin
      r.a[rr, vv].n := r.a[rr, vv].n - 1;
      if r.a[rr, vv].n = 0 then
         r.a[rr, vv].m := tuhi;
      rr := rr + dr; vv := vv + dv;
   end;
   s^.v := true;
end;

{ kontrollib, kas sna s sobib ristsnasse kohale k }
function sobib (var k : koht; var r : rist; s : sonaviit) : boolean;
var rr, vv, dr, dv, i : integer;
begin
   rr := k.r; vv := k.v;
   if k.s = 0 then begin
      dr := 0; dv := 1;
   end else begin
      dr := 1; dv := 0;
   end;
   for i := 1 to length (s^.s) do
      if (r.a[rr, vv].m = tuhi) or (r.a[rr, vv].m = s^.s[i]) then begin
         rr := rr + dr; vv := vv + dv;
      end else begin
         sobib := false;
         exit;
      end;
   sobib := true;
end;

{ otsib snastikust esimese sna, mis sobib ristsnasse kohale k }
function otsisona (var k : koht; var r : rist; var t : teek; var p : integer) : sonaviit;
var c1, c2, c : char; s : sonaviit;
begin
   if r.a[k.r, k.v].m = tuhi then begin
      c1 := 'A'; c2 := 'Z';
   end else begin
      c1 := r.a[k.r, k.v].m; c2 := r.a[k.r, k.v].m;
   end;
   for c := c1 to c2 do begin
      s := t.a[p, c];
      while s <> nil do begin
         if s^.v then
            if sobib (k, r, s) then begin
               otsisona := s;
               exit;
            end;
         s := s^.j;
      end;
   end;
   otsisona := nil;
end;

{ otsib snastikust snale s jrgneva sna, mis sobib ristsnasse kohale k }
function jargmine (var k : koht; var r : rist; var t : teek; s : sonaviit) : sonaviit;
var c, m : char; p : integer;
begin
   p := length (s^.s); m := s^.s[1];

   s := s^.j;
   while s <> nil do begin
      if s^.v then
         if sobib (k, r, s) then begin
            jargmine := s;
            exit;
         end;
      s := s^.j;
   end;

   if r.a[k.r, k.v].m = tuhi then
      for c := succ(m) to 'Z' do begin
         s := t.a[p, c];
         while s <> nil do begin
            if s^.v then
               if sobib (k, r, s) then begin
                  jargmine := s;
                  exit;
               end;
            s := s^.j;
         end;
      end;

   jargmine := nil;
end;

{ pab leida uue sna, mis sobib kohale k }
function leiasona (var k : koht; var r : rist; var t : teek) : boolean;
var p : integer; s : sonaviit;
begin
   if k.s = 0 then begin
      if (r.a[k.r, k.v].ar = r.a[k.r, k.v].lr) or
            (r.a[k.r, k.v].ar < k.v) then begin
         leiasona := not k.t;
         exit;
      end else begin
         p := r.a[k.r, k.v].lr - r.a[k.r, k.v].ar + 1;
         s := r.a[k.r, k.v].sr;
      end;
   end else begin
      if (r.a[k.r, k.v].av = r.a[k.r, k.v].lv) or
            (r.a[k.r, k.v].av < k.r) then begin
         leiasona := not k.t;
         exit;
      end else begin
         p := r.a[k.r, k.v].lv - r.a[k.r, k.v].av + 1;
         s := r.a[k.r, k.v].sv;
      end;
   end;
   if s = nil then
      s := otsisona (k, r, t, p)
   else begin
      votasona (k, r, s);
      s := jargmine (k, r, t, s);
   end;
   if s = nil then
      leiasona := false
   else begin
      panesona (k, r, s);
      leiasona := true;
   end;
end;

{ pab ristsna tagurdusmeetodil lahendada }
function lahenda (var r : rist; var t : teek) : boolean;
var k : koht;
begin
   algus (k);
   while true do begin
      if leiasona (k, r, t) then begin
         if not edasi (k, r) then begin
            lahenda := true;
            exit;
         end;
      end else begin
         if not tagasi (k, r) then begin
            lahenda := false;
            exit;
         end;
      end;
   end;
end;

{ vljastab leidud lahenduse }
procedure tee_valjund (var r : rist);
var f : text; i, j : integer;
begin
   assign (f, valf); rewrite (f);
   for i := 1 to r.r do begin
      for j := 1 to r.v do
         write (f, r.a[i, j].m);
      writeln (f);
   end;
   close (f);
end;

var
   r : rist;
   t : teek;
begin { phiprogramm }
   loe_sisend (r, t);
   if lahenda (r, t) then
      tee_valjund (r);
end.
